REBOL [
    Title: "navigateur CD"
 	Author: "J. Colineau"
 	Version: 1.6 
    	Date:  08-04-03
    	File:  %navigateur.r
    	Purpose: { navigateur CD }
	Comments: {boutons de style vh2
		tempo modifi pour dpart
		autres modifs (projection image-son)
		fonctions documentes
		}
]


fichier_image?: func[str][
	"est-ce un fichier image?"
	if/else any [find str ".jpg" 
        	find str ".gif"
		find str ".bmp"
		find str ".png"
    		][return true]
    		[return false]]
    		
fichier_texte?: func[str][
	"est-ce un fichier texte?"
	if/else any [find str ".htm" 
        find str ".html"
		find str ".doc"
		find str ".pdf"
		find str ".txt"
    		][return true]
    		[return false]]
    		
fichier_son?: func[str][
	"est-ce un fichier son?"
	found? find str ".wav"]

phrase?: func[str][
	"est-ce autre chose qu'un fichier image ou un ficher son?"
	if/else any [fichier_image? str
			fichier_son? str
    		][return false]
    		[return true]]
    		
ouvrir: func[fichier][
	{fonction de composition dynamique de layout
	version utilisant l'explorateur de windows
	appel par call}
	str: copy []
	append str "explorer.exe "
	append str make string! fichier
	reduce ['call str]
	] 

listefichiers: func[tableau][
	"fait la liste des fichiers du rpertoire courant"
	clear tableau		
	foreach file read %. [
    	if not dir? file [append tableau file] 
	]]


liste_fichiers_image: func [tableau][
	"fait la liste des fichiers image du rpertoire courant"
	tableau: head tableau
	clear tableau
	foreach file read %. [if (fichier_image? file)[append tableau file]]
	;tableau: sort tableau
	]

liste_fichiers_texte: func [tableau][
	"fait la liste desfichiers texte du rpertoire courant"
	tableau: head tableau
	clear tableau
	foreach file read %. [if (fichier_texte? file)[append tableau file]]
	]

		
listedir: func[tableau][
	"fait la liste des sous-rpertoires du rpertoire courant"
	clear tableau
	foreach file read %.[
    	if  dir? file [append tableau file]
	]]

go_up: does [  
    "Remonte au rpertoire parent."  
    if not what-dir = dir-origine [    change-dir %../ ]  
] 

ndir: func[var][
	"changement de rpertoire"
      if error? try [change-dir dirize rejoin [%./ var]][go_up]
      ;change-dir dirize rejoin [%./ var]
	rafraichir
	]

	
analyse_repertoire: func[ldir lfichiers liste_im liste_textes][
	" analyse la nature du rpertoire selon son contenu"
	foreach file lfichiers [if (fichier_image? file) [backimagefile: file]]
	if/else (exists? %index.r) [return 4] 
		[if/else (exists? %sommaire.txt)[return 5]
						[if/else (exists? %sequence.txt)[return 3]
								[if/else  (not empty? liste_textes) [return 5]
									[if/else (not empty? liste_im)
										[if/else ((length? liste_im) = 1) [backimagefile: first liste_im return 1][return 2]]
											[return 1]
										
									]
								]
						]
		]
	]

jouer: func [nomfichier] [
	{joue un fichier son au format .wav
	compatible avec certaines versions de Rebol}
	if error? try [
		snd: load nomfichier
		sndprt: open sound://
		wait 0.05
		insert sndprt snd
		wait sndprt
		close sndprt ] [wait 0:00:02]
	]

calcul_offset: func[im imagesize][
	"calcule un offset pour centrer l'image  prsenter"
	position: ((screensize - imagesize)  / 2x8)
	ratio: imagesize/x / imagesize/y
	ratioIm: im/size/x / im/size/y
	offset: make pair! 0x0
	if/else ((ratioIm - ratio ) < 0) [offset/x: ((imagesize/x - (imagesize/y  * ratioIm ))/ 2)]
		[offset/y:  (( imagesize/y -  (imagesize/x / ratioIm)) / 2 )]
	return (offset + position)]

navigation: func[][
	"trace l'cran correspondant  un rpertoire donn"
	screensize: system/view/screen-face/size
	;screensize: 800x600
	pos1: screensize / 80x60
	pos2: screensize / 80x60
	pos2/y: screensize/y * 0.95
	mainwin: copy [
	size screensize
 	backdrop backimagefile ;effect [aspect]
	style monbouton vh2 white effect [gradmul 1x0 50.50.50 128.128.128 ]
	at pos1
	guide
	monbouton "<  retour" [go_up rafraichir]]
	forall tdir[append mainwin reduce ['monbouton first parse/all (to-string tdir/1)  "/" append make block! [ndir] tdir/1]]
	append mainwin [
	at pos2
	monbouton "Quitter" [quit]
	return]
	mainwin: layout mainwin
	view center-face mainwin]

navigation_fichiers_texte: func[][
	"visualise sur l'cran les fichiers texte du rpertoire"
	screensize: system/view/screen-face/size
	;screensize: 800x600
	pos1: screensize / 80x60
	pos2: screensize / 80x60
	pos2/y: screensize/y * 0.95	
	mainwin: copy [
	size screensize
 	backdrop backimagefile  ;effect [aspect]
	style monbouton vh2 white effect [gradmul 1x0 50.50.50 128.128.128 ]
	at pos1
	guide
	monbouton "<  retour" [lftexte: head lftexte go_up rafraichir]]
	;version utilisant le browser
    foreach ftexte lftexte [append mainwin reduce ['monbouton first parse/all (to-string ftexte) "."  reduce ['browse ftexte]]]
    ;version utilisant l'explorateur de windows: appel par call
    ;forall lftexte [append mainwin reduce ['monbouton  first parse/all (to-string lftexte/1) "." ouvrir lftexte/1]]
	append mainwin [
	at pos2
	monbouton "Quitter" [quit]
	return]
	; pour tester la formation du layout ...
	;probe mainwin
	mainwin: layout mainwin
	view center-face mainwin]
	
projection: func[][
	"projecteur de diapos"
	arriere: 0
	liste_im: head liste_im
	screensize: system/view/screen-face/size
	imagesize: screensize * 0.8
	pad1: (screensize / 16) * 0x1
	pad2: ((screensize - 640 ) * 0.5 ) * 1x0
	ecran: layout [
	size screensize
	backdrop black
	below
	im: image imagesize black effect [aspect imagesize] rate tempo-init feel[			
								engage: func [face act evt]
								[ if act = 'time[
								if im/rate = tempo-init [im/rate: tempo]
								if not tail? liste_im[ im1: load first liste_im 								
								face/image: im1	 
								face/offset: calcul_offset im1 imagesize
								show face 
								if/else (arriere = 1) [liste_im: back liste_im]
								[liste_im: next liste_im]								
								]	
								]]] 
	style monbouton vh2 80x28 white effect [gradmul 1x0 50.50.50 128.128.128 ]
	pad pad1 
	across
	pad pad2
	monbouton "< retour " [liste_im: head liste_im go_up rafraichir]
	monbouton " |< " [projection]
	monbouton " << " [arriere: 1 liste_im: back liste_im im/rate: 0:00:01 show im]
	monbouton " >  " [arriere: 0 im/rate: tempo show im]
	monbouton " || " [im/rate: none show im]
	monbouton " >> " [arriere: 0 im/rate: 0:00:01 show im]
; 	monbouton "-" 28x28 [vtempo: vtempo -1 im/rate: to-time vtempo ir/text: vtempo show ir show im]
; 	ir: monbouton to-string vtempo 28x28 
; 	monbouton "+" 28x28 [vtempo: vtempo +1 im/rate: to-time vtempo ir/text: vtempo show ir show im]
	monbouton "Quitter" [quit]]
	view/options/offset ecran [no-title no-border] 0x0]

projection_texte_son: func[][
	"projecteur de diapos avec texte et son"
	commentaire: ""
	sequence: head sequence
	screensize: system/view/screen-face/size
	imagesize: screensize * 0.78
	pad1: (screensize / 32) * 0x1
	pad2: ((screensize - 640 ) * 0.5 ) * 1x0
	pad3: (screensize / (1x12))
	charsize: make integer! screensize/y / 32
	ecran: layout [
	size screensize
	backdrop black
	below
	im: image imagesize black effect [aspect imagesize] rate tempo-init feel[			
								engage: func [face act evt]
								[ if act = 'time
		[face/rate: none show face 
		sortir: 0
		while [not tail? sequence]
		[
		if fichier_image? first sequence
				[im1: load make file! first sequence texte_proj: ""
				face/image: im1	 
				face/offset: calcul_offset im1 imagesize
				show face
				if error? try [if fichier_image? second sequence [face/rate: tempo show face sortir: 1]][]
				]
		if phrase? first sequence [
				montexte/text: first sequence show montexte
				if error? try [
				if ((fichier_image? second sequence) or (phrase? second sequence)) [
				face/rate: tempo show face sortir: 1]][show face]
				]
		if fichier_son? first sequence [
				jouer make file! first sequence
				]
		sequence: next sequence
		if (sortir = 1) [break] 
				]]]]
	style monbouton vh2 80x24 white effect [gradmul 1x0 50.50.50 128.128.128 ]
	pad pad1
	montexte: text pad3 commentaire font [color: white size: charsize align: 'center]
	across
	pad pad2
	monbouton "< retour" [sequence: head sequence go_up rafraichir]
	monbouton "  >   " [im/rate: tempo show im]
	monbouton "  ||  " [im/rate: none show im]
	monbouton " >>  " [im/rate: 0:00:01 show im]
	monbouton
	monbouton "Quitter" [quit]]
	view/options/offset ecran [no-title no-border] 0x0]

rafraichir: func[][
	"fonction principale de traitement et de visualisation"
	backimagefile: ""
	listedir tdir
	listefichiers tfichiers
	liste_fichiers_image liste_im
	liste_fichiers_texte lftexte

	
	if exists? %sequence.txt [sequence: make list! read/lines %sequence.txt]
	;sequence: head sequence

	traitement:  analyse_repertoire tdir tfichiers liste_im lftexte
	switch traitement [
		0 []
		1 [navigation]
		2 [projection]
		3 [projection_texte_son]
		4 [do %index.r] 
		5 [navigation_fichiers_texte]
		]
	]

;--dbut du programme


tempo-init: 2
tempo: 0:00:05
controle: 0

;dir-origine: none 
;limite l'exploration aux sous-rpertoires en aval
dir-origine: what-dir

tdir: []
tfichiers: []
liste_im: []
lftexte: copy []
sequence: []

rafraichir
go_up rafraichir 

	
	



	
